---###369 Studios Present###---
---###The ZSEngine###---
---###Coded by lead and only programmer, dan369###---

--[[
ZSEngine Diary Log:

14th June 2010 - Work begins on the new engine, ZSE stands for "zombie shooter" engine.
24th June 2010 - Work re-begins on new laptop, yayyyyy!!
25th June 2010 - Working with the zombie death animation.
26th June 2010 - Working on player stuff now, mainly graphics.
28th June 2010 - Messing around with player graphics still. Minor mis-understanding with artist lead to errors.
30th June 2010 - Fixing Knifing animation. Took a day's break yesterday.
4th July 2010 - Finally think i've got the animation issues sorted, cursor code is wrong and needs to be re-done.
10th July 2010 - Animation sorted, cursor needs minor fixing, on to bullet delay system.
11th July 2010 - Bullet Delay System done, now working on fixing last minor bugs before moving on.
12th July 2010 - Adding in pistol.
14th July 2010 - Days break, pistol finally added in. Bullet positioning needs a touch up.
15th July 2010 - Bullet positioning still unsolved, gun swapping done, adding in seconded gun GFX.
18th August 2010 - Game nearering the end. Version 1.0 maybe by tonight? Or early tomorrow. 
2nd September 2010 - Game finally nearing first release. Deadline extended by 2 weeks. 
3rd September 2010 - Public Beta today! 
4th September 2010 - Working on improving a.i and adding in final touches to finsih off the game ;).
5th September 2010 - Improving A.i, and adding in sound effects.
13th September 2010 - Deadline day tomorrow, finsihing touches to game, adding in SFX effects, BG Music, fixed a few bugs and added a Background.
                      Probably my last entry, it's been a good ride and learning experience at least :D.
14th September 2010 - Deadline day, increased the challenge of the game, limited number of ammo boxes, faster zombie death animation and faster 
                      movement. 
]]--

--Load Sounds
machineGunFire = pge.wav.load("SFX/machinegun_fire.wav");
pistolFire = pge.wav.load("SFX/pistol_fire.wav");
shotgunFire = pge.wav.load("SFX/shotgun_fire.wav");
zombieHit = pge.wav.load("SFX/hit.wav");

--Zombie Images
zombieAttacking = pge.texture.load("Images/Zombies/zombieAttacking.png", PGE_VRAM);
zombieDeath = pge.texture.load("Images/Zombies/zombieDeath.png", PGE_VRAM);
zombieWalking = pge.texture.load("Images/Zombies/zombieWalking.png", PGE_VRAM);

--Zombie Animation Tables
zombieAttackingAnim = {animTime = pge.timer.create(), totalTime = 0, startFrame = 0, endFrame = 4, oldFrame = 0, maxTime = 0.3}; 
zombieWalkingAnim = {animTime = pge.timer.create(), totalTime = 0, startFrame = 0, endFrame = 4, oldFrame = 0, maxTime = 0.25};

--Zombie Table
zombiesKilled = 0;
zombie = {}

--Create Zombies for this round
for i = 1, 200 do
	zombie[i] = {x = 0, y = 0, angle = 0, img = zombieWalking, width = 64, height = 64, health = 50, angle = 0,
		currentSprite = zombieWalkingAnim.startFrame, walking = true, attacking = false, dead = false, deadCounter = 0, 
		attackDelay = false, attackDelayCounter = 0, animTime = pge.timer.create(), totalTime = 0, startFrame = 0, endFrame = 4,
		oldFrame = 0, maxTime = 0.8, posX = math.random(1, 2), posY = math.random(1, 2), dropAmmo = math.random(1, 3), active = true};
end

--Gun Types constants
Pistol = 1;
AssaultRifle = 2
Shotgun = 3;

--Guns Tables
guns = {};
guns[1] = {name = "M1911", dmg = 15, model = Pistol, reloadTime = 100, currentClip = 12, clipSize = 12, currentAmmo = 24, maxAmmo = 80, 
	currentDelayTime = 0, maxDelayTime = 4, empty = false};
guns[2] = {name = "M4Carbine", dmg = 10, model = AssaultRifle, reloadTime = 200, currentClip = 30,  clipSize = 30, currentAmmo = 120, maxAmmo = 240, 
	currentDelayTime = 0, maxDelayTime = 4, empty = false};
guns[3] = {name = "PGS-10", dmg = 25, model = Shotgun, reloadTime = 150, currentClip = 12, clipSize = 12, currentAmmo = 12, maxAmmo = 60, 
	currentDelayTime = 0, maxDelayTime = 30, empty = false};
	
--Player images 
playerWalkingImg = pge.texture.load("Images/Player/playerWalking.png", PGE_RAM);
--playerKnifingImg = pge.texture.load("Images/Player/playerKnifing.png", PGE_RAM);
playerDeathImg = pge.texture.load("Images/Player/playerDeath.png", PGE_RAM); 
playerPistolImg = pge.texture.load("Images/Player/playerPistol.png", PGE_VRAM);
playerBigGunsImg = pge.texture.load("Images/Player/playerBigGuns.png", PGE_RAM);

playerWalkingHitImg = pge.texture.load("Images/Player/playerWalkingHit.png", PGE_RAM);
playerPistolHitImg = pge.texture.load("Images/Player/playerPistolHit.png", PGE_RAM);
playerBigGunsHitImg = pge.texture.load("Images/Player/playerBigGunsHit.png", PGE_RAM);

--Weapon images
M1911 = pge.texture.load("Images/Guns/M1911.png", PGE_VRAM);
M4Carbine = pge.texture.load("Images/Guns/M4Carbine.png", PGE_VRAM);
PGS10 = pge.texture.load("Images/Guns/PGS-10.png", PGE_VRAM);
	
--Player Animation Tables
playerWalking = {animTime = pge.timer.create(), totalTime = 0, startFrame = 0, endFrame = 6, oldFrame = 0, maxTime = 0.3};
playerKnifing = {animTime = pge.timer.create(), totalTime = 0, startFrame = 0, endFrame = 3, oldFrame = 0, maxTime = 0.4}; 
playerDeath = {animTime = pge.timer.create(), totalTime = 0, startFrame = 0, endFrame = 8, oldFrame = 0, maxTime = 0.85}; 
playerPistol = {animTime = pge.timer.create(), totalTime = 0, startFrame = 0, endFrame = 5, oldFrame = 0, maxTime = 0.3};
playerBigGuns = {animTime = pge.timer.create(), totalTime = 0, startFrame = 0, endFrame = 5, oldFrame = 0, maxTime = 0.3};

--Player Table
player = {worldX = 200, worldY = 70, img = playerWalkingImg, currentSprite = playerWalking.startFrame, width = 48, height = 140, speed = 1, 
	currentGun = guns[1], firstGun = guns[1], secondGun = guns[3], gunCount = 0, currentBullet = 1, reloading = false, rTime = 0, unarmed = true, 
	knifing = false, health = 100, armor = 100, death = false, score = 0, runTime = 40, hit = false, hitTimer = 0};

--Player Cursor 
cursor = {x = 0, y = 0, img = pge.texture.load("Images/Misc/angle.png",PGE_VRAM)};

--Ammo
ammo = {};
ammoCrate = pge.texture.load("Images/Misc/ammo.png", PGE_VRAM);

--Machine Gun
machineGun = {x = math.random(38, 340), y = math.random(38, 240), appear = math.random(4, 6), hit = false, img = pge.texture.load("Images/Misc/crate.png", PGE_RAM)};

--Bg image
bg = pge.texture.load("Images/Misc/bg.png", PGE_RAM);

--Round counter
round = {number = 1, zombies = 4};

--Create Inital Bullets
bulletImg = pge.texture.create(2, 5, PGE_PIXEL_FORMAT_8888, PGE_VRAM);
bulletImg:settarget();
pge.gfx.clearscreen(white);
pge.gfx.rendertoscreen();
bullets = {};
for i = 1, 30 do
	bullets[i] = {worldX = 0, worldY = 0, renderX = 0, renderY = 0, angleX = 0, angleY = 0, img = bulletImg, fired = false, delay = false, move = false};
end

-----------------------------------------#######Functions#######------------------------------------- ----
function fireBullets()
	if not bullets[player.currentBullet].fired and not player.reloading and not player.currentGun.empty and player.currentGun.currentDelayTime == 0 then
		if player.currentGun.model == Pistol then
			bullets[player.currentBullet].angleX = angleX;
			bullets[player.currentBullet].angleY = angleY;
			bullets[player.currentBullet].worldX = (player.worldX + player.width / 2) + (bullets[player.currentBullet].angleX * 60);
			bullets[player.currentBullet].worldY = (player.worldY + player.height / 2) + (-bullets[player.currentBullet].angleY * 60);
			bullets[player.currentBullet].fired = true;
			bullets[player.currentBullet].delay = true;
		elseif player.currentGun.model == AssaultRifle then
			bullets[player.currentBullet].angleX = angleX;
			bullets[player.currentBullet].angleY = angleY;
			bullets[player.currentBullet].worldX = (player.worldX + player.width / 2) - (bullets[player.currentBullet].img:width() / 2) + (bullets[player.currentBullet].angleX * 60) ;
			bullets[player.currentBullet].worldY = (player.worldY + player.height / 2) + (bullets[player.currentBullet].img:height() / 2) + (-bullets[player.currentBullet].angleY * 60);
			bullets[player.currentBullet].fired = true;
			bullets[player.currentBullet].delay = true;
		elseif player.currentGun.model == Shotgun then
			for i = player.currentBullet, player.currentBullet+2 do
				--AngleX/Y
				bullets[i].angleX = angleX;
				bullets[i].angleY = angleY;
				--Set bullets to fired/delay
				bullets[i].fired = true;
				bullets[i].delay = true;
				bullets[i].move = true;
			end
			--Centre Bullet
			bullets[player.currentBullet].worldX = (player.worldX + bullets[player.currentBullet].angleX * 65) - (bullets[player.currentBullet].img:width() / 2) + (player.width / 2);
			bullets[player.currentBullet].worldY = (player.worldY + -bullets[player.currentBullet].angleY * 65) - (bullets[player.currentBullet].img:height() / 2) + (player.height / 2);
			--Left Bullet
			bullets[player.currentBullet+1].worldX = bullets[player.currentBullet].worldX - (pge.math.sin((angle + 90 * math.pi/180)) * 8) - (bullets[player.currentBullet].img:width() / 2); 
            bullets[player.currentBullet+1].worldY = bullets[player.currentBullet].worldY + (pge.math.cos((angle + 90 * math.pi/180)) * 8) - (bullets[player.currentBullet].img:height() / 2);
			--Right bullet
			bullets[player.currentBullet+2].worldX = bullets[player.currentBullet].worldX + (pge.math.sin((angle + 90 * math.pi/180)) * 8) + (bullets[player.currentBullet].img:width() / 2); 
            bullets[player.currentBullet+2].worldY = bullets[player.currentBullet].worldY - (pge.math.cos((angle + 90 * math.pi/180)) * 8) + (bullets[player.currentBullet].img:height() / 2);		
		end
	end
		
	--Have we fired the last bullet? Our have we still got ammo?
	if bullets[player.currentGun.currentClip].fired and player.currentGun.currentAmmo == 0 then
		player.currentGun.empty = true;
	elseif bullets[player.currentGun.currentClip].fired and not player.currentGun.empty then
		player.reloading = true;
		
		if player.currentGun.currentAmmo >= player.currentGun.clipSize then
			player.currentGun.currentClip = player.currentGun.clipSize;
		elseif player.currentGun.currentAmmo < player.currentGun.clipSize then
			player.currentGun.currentClip = player.currentGun.currentAmmo;
		end
	end
	
	if player.currentBullet < player.currentGun.currentClip and not player.reloading and player.currentGun.currentDelayTime == 0 then
		if player.currentGun.model == Pistol or player.currentGun.model == AssaultRifle then
			player.currentBullet = player.currentBullet + 1;
		elseif player.currentGun.model == Shotgun then
			player.currentBullet = player.currentBullet + 3;
		end
	else
		player.currentBullet = 1;
	end
end

function zombies() 
local collision;
local numOfZombies = round.number * round.zombies;

	for i = 1, numOfZombies do
		if zombie[i].active then
			--Zombie Animation
			if zombie[i].walking and not zombie[i].attacking and not zombie[i].dead and not zombie[i].attackDelay then
				zombie[i].img = zombieWalking;
				zombie[i].currentSprite = zombieWalkingAnim.startFrame;
				zombieWalkingAnim.animTime:update();
				pge.gfx.animateadvanced(zombieWalkingAnim, true);
			elseif zombie[i].attacking then
				zombie[i].img = zombieAttacking;
				zombie[i].currentSprite = zombieAttackingAnim.startFrame;
				zombieAttackingAnim.animTime:update();
				pge.gfx.animateadvanced(zombieAttackingAnim, false);
			
				--Have we completed attacking cycle?
				if zombieAttackingAnim.startFrame == zombieAttackingAnim.endFrame then
					zombie[i].attacking = false 
					zombie[i].attackDelay = true;
				end
			elseif zombie[i].attackDelay then
				zombieAttackingAnim.startFrame = 0;
				zombie[i].img = zombieWalking;
				zombie[i].currentSprite = 0; 
				zombie[i].attackDelayCounter = zombie[i].attackDelayCounter + 1;
			
			--Reached end of attack delay?
			if zombie[i].attackDelayCounter > 100 then
				zombie[i].walking = true;
				zombie[i].attackDelayCounter = 0;
				zombie[i].attackDelay = false;
			end
			elseif zombie[i].dead then
				zombie[i].img = zombieDeath;
				zombie[i].currentSprite = zombie[i].startFrame
				zombie[i].animTime:update();
				pge.gfx.animateadvanced(zombie[i], false);  
				zombie[i].deadCounter = zombie[i].deadCounter + 1;
			end
		
			--Bullet collision
			for a = 1, #bullets do
				if bullets[a].fired and not zombie[i].dead and bullets[a].worldX + bullets[a].img:width() > (zombie[i].x + 16) and bullets[a].worldX < (zombie[i].x + 16) + (zombie[i].width - 29) and bullets[a].worldY + bullets[a].img:height() > (zombie[i].y + 16) and bullets[a].worldY < (zombie[i].y) + (zombie[i].height - 28) then
					player.score = player.score + 100;
					zombie[i].dead = true;
					zombie[i].walking = false;
					bullets[a].fired = false;
					zombieHit:play(); --play hit sound
				
					--Has the zombie got any goodies for us?
					if zombie[i].dropAmmo == 1 and #ammo < 4 then
						ammo[#ammo + 1] = {x = zombie[i].x + (zombie[i].width / 2), y = zombie[i].y + (zombie[i].img:height() / 2), img = ammoCrate, used = false};
					end
				end
			end

			--Find the Angle of the Zombie to face the player
			if not zombie[i].dead and not zombie[i].attacking and player.worldX ~= zombie[i].x and player.worldY ~= zombie[i].y then
				if player.worldX < zombie[i].x and player.worldY > (zombie[i].y - 10) then
					zombie[i].angle = math.atan(((player.worldY - zombie[i].y)) / (player.worldX - zombie[i].x)) - math.rad(270);
				elseif player.worldX < zombie[i].x and player.worldY <= (zombie[i].y - 10) then
					zombie[i].angle = math.atan(((player.worldY - zombie[i].y)) / (player.worldX - zombie[i].x)) + math.rad(90);
				elseif player.worldX + (player.width-10) >= zombie[i].x and player.worldY > (zombie[i].y - 10) then
					zombie[i].angle = math.atan(((player.worldY - zombie[i].y)) / (player.worldX - zombie[i].x)) + math.rad(270);
				elseif player.worldX + (player.width-10) >= zombie[i].x and player.worldY < (zombie[i].y - 10) then
					zombie[i].angle = math.atan(((player.worldY - zombie[i].y)) / (player.worldX - zombie[i].x)) - math.rad(90); 
				end
			end
		
			--Collision With Player
			if not zombie[i].attackDelay and not zombie[i].dead and player.worldX + (player.width-12) >= zombie[i].x and player.worldX <= (zombie[i].x + 16) + (zombie[i].width - 32) and player.worldY + (player.height - 67) > zombie[i].y and player.worldY <= (zombie[i].y + 6) then
				if player.armor > 0 and not zombie[i].attacking then
					player.armor = player.armor - 5;
				elseif player.armor <= 0 and not zombie[i].attacking then
					player.health = player.health - 10;
				end
				zombie[i].attacking = true;
				player.hit = true;
			end
		
			--Have we killed the player?
			if player.health <= 0 then
				player.unarmed = true;
				player.death = true;
			end
		
			--Chase Player :)
			if not zombie[i].dead and not zombie[i].attackDelay then
				if (zombie[i].y + 5) >= (player.worldY) then
					zombie[i].y = zombie[i].y - 0.65;
				elseif (zombie[i].y) <= (player.worldY + 70) then
					zombie[i].y = zombie[i].y + 0.65;
				end
				
				if zombie[i].x >= player.worldX then
					zombie[i].x = zombie[i].x - 0.65;
				elseif zombie[i].x < player.worldX then
					zombie[i].x = zombie[i].x + 0.65;
				end
			end
		
			--Render zombies
			zombie[i].img:activate();
			zombie[i].img:draw(zombie[i].x, zombie[i].y, zombie[i].width, zombie[i].height, zombie[i].currentSprite * zombie[i].width, 0, zombie[i].width, 
				zombie[i].height, zombie[i].angle);
			
			--Clean up dead zombies
			if zombie[i].deadCounter > 200 then
				zombiesKilled = zombiesKilled + 1;
				zombie[i].active = false;
				zombie[i].dead = false;
				zombie[i].deadCounter = 0;
				zombie[i].posX = math.random(1, 2);
				zombie[i].posY = math.random(1, 2);
				zombie[i].dropAmmo = math.random(1, 2);
			end
		end
	end
end 

function updatePlayer()
	if not player.death then
		--[[Are we knifing?
		if pge.controls.pressed(PGE_CTRL_SQUARE) and not player.knifing then
			player.img = playerKnifingImg;
			player.knifing = true;
		end
		]]--

		--Or are we moving and unarmed? 
		if pge.controls.held(PGE_CTRL_RTRIGGER) and player.unarmed then
			player.worldX = player.worldX + angleX * player.speed;
			player.worldY = player.worldY + -angleY * player.speed;
		
			--Walking Animation
			if not player.knifing then
				player.currentSprite = playerWalking.startFrame;
				playerWalking.animTime:update();
				pge.gfx.animateadvanced(playerWalking, true);
			end
		elseif not pge.controls.held(PGE_CTRL_RTRIGGER) and not player.knifing then
			playerWalking.startFrame = 0;
			player.currentSprite = 0;
		end
	
		--Or are we moving but are armed and if so with what?
		if pge.controls.held(PGE_CTRL_RTRIGGER) and not player.unarmed and not player.knifing then
			player.worldX = player.worldX + angleX * player.speed;
			player.worldY = player.worldY + -angleY * player.speed;
		
			--What gun model are we using?
			if player.currentGun.model == Pistol then
				player.img = playerPistolImg;
			elseif player.currentGun.model == AssaultRifle or player.currentGun.model == Shotgun then
				player.img = playerBigGunsImg;
			end
		
		--Walking Animation
		if not player.knifing then
			if player.currentGun.model == Pistol then
				player.currentSprite = playerPistol.startFrame;
				playerPistol.animTime:update();
				pge.gfx.animateadvanced(playerPistol, true);
			elseif player.currentGun.model == AssaultRifle or player.currentGun.model == Shotgun then
				player.currentSprite = playerBigGuns.startFrame;
				playerBigGuns.animTime:update();
				pge.gfx.animateadvanced(playerBigGuns, true);
			end
		end
		elseif not pge.controls.held(PGE_CTRL_RTRIGGER) and not player.knifing and not player.unarmed then
			if player.currentGun.model == Pistol then
				playerPistol.startFrame = 0;
				player.currentSprite = 2;
			elseif player.currentGun.model == AssaultRifle or player.currentGun.model == Shotgun then
				playerBigGuns.startFrame = 0;
				player.currentSprite = 2;
			end
		end
		
		--Are we running?
		if pge.controls.held(PGE_CTRL_RTRIGGER) and pge.controls.held(PGE_CTRL_LTRIGGER) and player.runTime >= 0 then
			player.speed = 2.2;
			player.runTime = player.runTime - 0.5;
			
			--Set the max-time to running pace.
			if player.unarmed then
				playerWalking.maxTime = 0.2;
			elseif player.currentGun.model == Pistol then
				playerPistol.maxTime = 0.2;
			elseif player.currentGun.model == AssaultRifle or player.currentGun.model == Shotgun then
				playerBigGuns.maxTime = 0.2;
			end
		elseif not pge.controls.pressed(PGE_CTRL_LTRIGGER) and player.runTime <= 40 then
			player.speed = 1.2;
			player.runTime = player.runTime + 0.1;
			
			--Set the max-time back to normal walking pace.
			if player.unarmed then
				playerWalking.maxTime = 0.3;
			elseif player.currentGun.model == Pistol then
				playerPistol.maxTime = 0.3;
			elseif player.currentGun.model == AssaultRifle or player.currentGun.model == Shotgun then
				playerBigGuns.maxTime = 0.3;
			end
		end
	
		--Player Changing Equipment
		if pge.controls.pressed(PGE_CTRL_TRIANGLE) and not player.knifing and not player.reloading then
			player.gunCount = player.gunCount + 1;
		
			--If we've changed to 3rd gun, then were back at unarmed
			if player.gunCount == 3 then
				player.gunCount = 0;
			end
		
			if player.gunCount == 0 then
				player.unarmed = true;
			elseif player.gunCount == 1 then
				player.currentGun = player.firstGun;	
				player.currentBullet = 1;			
				player.unarmed = false;
			elseif player.gunCount == 2 then
				player.currentGun = player.secondGun;	
				player.currentBullet = 1;			
				player.unarmed = false;
			end
		
			if player.unarmed then
				player.img = playerWalkingImg;
				playerWalking.startFrame = 0;
				player.currentSprite = 0;
			elseif not player.unarmed and player.currentGun.model == Pistol then
				player.img = playerPistolImg;
				playerPistol.startFrame = 0;
				player.currentSprite = 2;
			elseif not player.unarmed and player.currentGun.model == AssaultRifle or player.currentGun.model == Shotgun then
				player.img = playerBigGunsImg;
				playerBigGuns.startFrame = 0;
				player.currentSprite = 2;
			end
		end
	
		--[[Player Knifing 
		if player.knifing then
			player.currentSprite = playerKnifing.startFrame;
			playerKnifing.animTime:update();
			pge.gfx.animateadvanced(playerKnifing, false);
			
			--Position knifing collision object
			if playerKnifing.startFrame == 0 then
				knifingCol.img = knifingColImg;
			elseif playerKnifing.startFrame == 1 then
				knifingCol.img = knifingColImg2;
			elseif playerKnifing.startFrame == 2 then
				knifingCol.img = knifingColImg3;
			end

			if playerKnifing.startFrame == playerKnifing.endFrame then
				if player.unarmed then
					player.img = playerWalkingImg;
					player.currentSprite = playerWalking.startFrame;
				elseif not player.unarmed then
					if player.currentGun.model == Pistol then
						player.img = playerPistolImg;
						player.currentSprite = playerPistol.startFrame;
						playerPistol.startFrame = 0;
					elseif player.currentGun.model == AssaultRifle or player.currentGun.model == Shotgun then
						player.img = playerBigGunsImg;
						player.currentSprite = playerBigGuns.startFrame;
						playerBigGuns.startFrame = 0;
					end
				end
			
				playerKnifing.startFrame = 0;	
				playerKnifing.totalTime = 0;
				player.knifing = false;
			end
		end
		]]--
		
		--Have we been hit?
		if player.hit then
			player.hitTimer = player.hitTimer + 1;
			
			if player.currentGun.model == Pistol and not player.unarmed then
				player.img = playerPistolHitImg;
			elseif not player.unarmed and player.currentGun.model == AssaultRifle or player.currentGun.model == Shotgun then
				player.img = playerBigGunsHitImg;
			elseif player.unarmed then
				player.img = playerWalkingHitImg;
			end
			
			if player.hitTimer > 20 then
				player.hit = false;
				player.hitTimer = 0;
				
				if player.unarmed then
					player.img = playerWalkingImg;
				elseif not player.unarmed and player.currentGun.model == Pistol then
					player.img = playerPistolImg;
				elseif not player.unarmed and player.currentGun.model == AssaultRifle or player.currentGun.model == Shotgun then
					player.img = playerBigGunsImg;				
				end	
			end
		end
		
		--Have we gone out of view?
		if player.worldX <= -29 then
			player.worldX = 458.5;
		elseif player.worldX >= 461 then
			player.worldX = -28.5;
		end
		
		if player.worldY <= -72 then
			player.worldY = 197;
		elseif player.worldY >= 204 then
			player.worldY = -67;
		end
	
		--Player Shooting
		if not player.unarmed then
			if player.currentGun.model == Pistol or player.currentGun.model == Shotgun and not player.reloading and not player.currentGun.empty and
				player.currentGun.currentDelayTime == 0 then
					if pge.controls.pressed(PGE_CTRL_CROSS) then
						fireBullets();
						
						if player.currentGun.model == Pistol and not player.reloading then
							--Play pistol firing sound
							pistolFire:play();
						elseif player.currentGun.model == Shotgun then
							--Play shotgun firing sound~
							shotgunFire:play();
						end
					end
			elseif player.currentGun.model == AssaultRifle and not player.reloading and not player.currentGun.empty 
				and player.currentGun.currentDelayTime == 0 then
					if pge.controls.held(PGE_CTRL_CROSS) then
						fireBullets();
						--Play machine gun firing sound
						machineGunFire:play();
					end		
				end
			end
	
		--Found any ammo?
		if player.currentGun.currentAmmo > 0 and not player.unarmed and player.currentGun.empty then
			player.currentGun.empty = false;
			player.reloading = true;
		end
	
		--Bullet Delay 
		if player.currentBullet > 1 and player.currentBullet <= player.currentGun.clipSize then
			if bullets[player.currentBullet - 1].delay then
				player.currentGun.currentDelayTime = player.currentGun.currentDelayTime + 1;
	
				if player.currentGun.currentDelayTime >= player.currentGun.maxDelayTime then
					player.currentGun.currentDelayTime = 0;
					bullets[player.currentBullet - 1].delay = false;
				end
			end
		end
		
		--Reloading
		if player.reloading and not player.currentGun.empty then
			player.rTime = player.rTime + 1;
			
			if player.currentGun.currentAmmo >= player.currentGun.clipSize then
				player.currentGun.currentClip = player.currentGun.clipSize;
			elseif player.currentGun.currentAmmo < player.currentGun.clipSize then
				player.currentGun.currentClip = player.currentGun.currentAmmo;
			end
			
			if player.rTime >= player.currentGun.reloadTime then
				player.currentGun.currentAmmo = player.currentGun.currentAmmo - player.currentGun.currentClip;
				player.rTime = 0;
				player.reloading = false;
			end
		end
	end	
end

function renderBullets()
local i;
bulletImg:activate();

	for i = 1, #bullets do
		if bullets[i].fired then
			bullets[i].renderX = bullets[i].worldX;
			bullets[i].renderY = bullets[i].worldY;
			bullets[i].img:draweasy(bullets[i].renderX, bullets[i].renderY);
		
			--Update Positions
			if not bullets[i].move then
				bullets[i].worldX = bullets[i].worldX + bullets[i].angleX * 4;	
				bullets[i].worldY = bullets[i].worldY + -bullets[i].angleY * 4;
			else
				bullets[i].worldX = bullets[i].worldX + bullets[i].angleX * 4;	
				bullets[i].worldY = bullets[i].worldY + -bullets[i].angleY * 4;	
			end
			
			--Reset my bullets
			if bullets[i].worldX > 480 or bullets[i].worldX < 0 or bullets[i].worldY < 0 or bullets[i].worldY > 272 and not player.reloading then
				bullets[i].fired = false;
			end
		end
	end
end

function renderAmmoCrates()
local a;
ammoCrate:activate();

	for a, crates in ipairs(ammo) do
		if not ammo[a].used then
			--Draw ammo crates
			ammoCrate:draweasy(ammo[a].x, ammo[a].y);
		
			--Check collision with player 
			if player.worldX + (player.width-12) >= ammo[a].x and player.worldX <= (ammo[a].x + ammoCrate:width()) and player.worldY + (player.height - 67) >= ammo[a].y and player.worldY <= (ammo[a].y + ammoCrate:height()) then
				player.currentGun.currentAmmo = player.currentGun.currentAmmo + 6;
				player.score = player.score + 50;
				ammo[a].used  = true;
			end
		elseif ammo[a].used then
			table.remove(ammo, a);
		end
	end
end

function updateCursor()
	--Cursor Update, Check if the analog stick has moved
	if not player.death then
		angle = pge.controls.analogangle();
		
		angleX = math.sin(angle);
		angleY = math.cos(angle);
		cursor.x = (player.worldX  + (angleX * 75)) - (cursor.img:width() / 2) + (player.width / 2);
		cursor.y = (player.worldY + (-angleY * 75)) - (cursor.img:height() / 2) + (player.height / 2);
	end
end

function drawEverything()
	--Render background
	bg:activate();
	bg:draweasy(0, 0);
	--Render Bullets
	renderBullets();
	--Render Ammo Crates
	renderAmmoCrates();
	--Render Player
	if not player.death then
		player.img:activate();
		player.img:draw(player.worldX, player.worldY, player.width, player.height, player.currentSprite * player.width, (player.height - 140), player.width, 
			player.height, angle);	
	elseif player.death then
		player.width = 64;
		player.currentSprite = playerDeath.startFrame
		playerDeath.animTime:update();
		pge.gfx.animateadvanced(playerDeath, false);
		playerDeathImg:activate();
		playerDeathImg:draw(player.worldX, player.worldY, player.width, player.height, player.currentSprite * player.width, (pge.math.floor(player.currentSprite/8)) * player.height, player.width, 
			player.height, angle);	
	end
	--Render Current Weapon
	if not player.unarmed and not player.knifing then
		if player.currentGun.model == Pistol then
			if player.currentGun.name == "M1911" then
				M1911:activate();
				M1911:draweasy((player.worldX  + angleX) - (M1911:width() / 2) + (player.width / 2), 
					(player.worldY + angleY) - (M1911:height() / 2) + (player.height / 2), angle);
			end
		elseif player.currentGun.model == AssaultRifle or player.currentGun.model == Shotgun then		
			if player.currentGun.name == "M4Carbine" then
				M4Carbine:activate();
				M4Carbine:draweasy((player.worldX  + angleX) - (M4Carbine:width() / 2) + (player.width / 2), 
					(player.worldY + angleY) - (M4Carbine:height() / 2) + (player.height / 2), angle);
			elseif player.currentGun.name == "PGS-10" then
				PGS10:activate();
				PGS10:draweasy((player.worldX  + angleX) - (PGS10:width() / 2) + (player.width / 2), 
					(player.worldY + angleY) + (PGS10:height() / 2) - (player.height / 2), angle);
			end
		end
	end
	
	--Render Machine Gun crate
	if not machineGun.hit and machineGun.appear <= round.number then
		machineGun.img:activate();
		machineGun.img:draweasy(machineGun.x, machineGun.y);
		
		if not player.unarmed and player.worldX + (player.width + 12) > machineGun.x and (player.worldX - 12) < machineGun.x + 32 and player.worldY + (player.height - 45) > machineGun.y and player.worldY < machineGun.y + 32 then
			if player.currentGun.model == Pistol then
				player.firstGun = guns[2];
				player.currentGun = player.firstGun;
			elseif player.currentGun.model == Shotgun then
				player.secondGun = guns[2];
				player.currentGun = player.secondGun;
			end
			player.currentBullet = 1;
			machineGun.hit = true;
		end
	end
	
	--Render Cursor
	cursor.img:activate();
	cursor.img:draweasy(cursor.x, cursor.y);
end
	
--Advanced Animation function
function pge.gfx.animateadvanced(ATime, Constant)
Constant = Constant;
ATime.totalTime = ATime.totalTime + ATime.animTime:getdelta();

		if ATime.totalTime >= ATime.maxTime then
			ATime.totalTime = 0;
			ATime.startFrame = ATime.startFrame+1;
			
		if Constant and ATime.startFrame >= ATime.endFrame then
			ATime.startFrame = ATime.oldFrame;
		elseif not Constant and ATime.startFrame >= ATime.endFrame then
			ATime.totalTime = 0;
			ATime.startFrame = ATime.endFrame;
		end
	end
end