--Load Resources
font = pge.font.load("Fonts/verdana.ttf", 8, PGE_RAM);
bloodFont = pge.font.load("Fonts/Manson_Nights.ttf", 18, PGE_RAM);

--Create Colours
white = pge.gfx.createcolor(255, 255, 255);
red = pge.gfx.createcolor(255, 0, 0);
HalfAlpha = pge.gfx.createcolor(255, 0, 0, 75)

--Load Engine and game file
engine = loadfile("ZSEngine.lua");
game = loadfile("game.lua");
engine();

--Load Dash Hacks Logo
logo = {x = 90, y = 280, ySpeed = 2.5, img = pge.texture.load("Images/Misc/logo.png")};

--Set Debug and set the random seed
Debug = false; 
local pressedX = false;
local countDown = 0;
local showLogo = false;
math.randomseed(123456789);

while pge.running() do
	pge.controls.update();
	pge.gfx.startdrawing();
	pge.gfx.clearscreen();
	
	if pge.controls.pressed(PGE_CTRL_CROSS) then
		pressedX = true;
	end
	
	bloodFont:activate();
	if not pressedX then
		bloodFont:print(150, 254, red, "Press X to begin....");
	elseif pressedX and not showLogo then
		bloodFont:print(0, 250, red, "PSP-Hacks.com Homebrew Horror Show!");
		bloodFont:print(150, 160, red, "Countdown: "..tostring(500 - countDown));
		bloodFont:print(48, 10, red, "Delta Force created by dan369");
		bloodFont:print(48, 28, red, "Thanks to hardhat and yaustar for their help!");
		bloodFont:print(48, 46, red, "And to those who helped motivate me!");
		bloodFont:print(48, 64, red, "Lastly, i'd like to thank my testers; ");
		bloodFont:print(48, 82, red, "shadowjaz2, Organized_Chaos and ");
		bloodFont:print(48, 100, red, "hardhat (again :P). ");
		
		countDown = countDown + 1;
		
		if countDown > 500 then
			showLogo = true;
		end
	end
	
	if showLogo then
		pge.gfx.clearscreen(white);
		logo.img:activate();
		logo.y = logo.y - logo.ySpeed;
		logo.img:draweasy(logo.x, logo.y);
		
		if logo.y <= 0 then
			logo.y = 0;
			logo.ySpeed = 0;
			bloodFont:activate();
			bloodFont:print(0, 250, red, "PSP-Hacks.com Homebrew Horror Show!");
			bloodFont:print(0, 0, red, "Now, press start to REALLY begin the game...");
			
			if pge.controls.pressed(PGE_CTRL_START) then
				game();
			end
		end
	end

	--End drawing & swap the buffers
	pge.gfx.enddrawing();
	pge.gfx.swapbuffers();
end